#include <DosSharkX.h>
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <time.h>
#include <commctrl.h>
#ifndef INITCOMMONCONTROLSEX
typedef struct {
	DWORD dwSize;
	DWORD dwICC;
} INITCOMMONCONTROLSEX,*LPINITCOMMONCONTROLSEX;
#endif
#ifndef InitCommonControlsEx
int WINAPI InitCommonControlsEx(LPINITCOMMONCONTROLSEX);
#endif

#ifndef fcloseall
	#define fcloseall _fcloseall
#endif

char buf[100];

HANDLE DOSBOX_HANDLE;
HWND dosbox_hwnd;

char bc[SCAN_SIZE];
char attached=0;
long pid;
int scanning=0;
unsigned long ds_base;
unsigned long ds_start;
char ds_path[256];
char ds_name[9];


void TempScanClean(void)
{
	remove("scan.tmp");
	remove("scan2.tmp");
}


int __FindDOSBOX_callback(HWND wnd, LPARAM lparam)
{
	char wndtext[sizeof(TITLE_TEXT)+1];
	memset(wndtext,0,sizeof(TITLE_TEXT)+1);
	GetWindowText(wnd,wndtext,sizeof(TITLE_TEXT));
	if(strcmp(TITLE_TEXT,wndtext) == 0)
	{
		dosbox_hwnd=wnd;
		return 0;
	}
	
	return 1;
}

int FindDOSBOX(void)
{
	dosbox_hwnd=0;
	EnumWindows((void*)__FindDOSBOX_callback,0);
	if(!dosbox_hwnd)
	{
		return 0;
	}
	
	GetWindowThreadProcessId(dosbox_hwnd,&pid);
	DOSBOX_HANDLE = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid);
	if(!DOSBOX_HANDLE)
	{
		return 0;
	}
	return 1;
}

int load_ccode(ccode* code, char* str)
{
	return sscanf(str,"%1X%6X%X",&code->size,&code->offset,&code->value);
}

void save_ccode(ccode* code, char* str)
{
	sprintf(str,"%.1X%.6X%X",code->size,code->offset,code->value);
}


HINSTANCE hInstance;
HICON hIcon;
HICON hIconSm;

HWND dosshark_main = 0;
HWND dosshark_scanner = 0;
HWND dosshark_codes = 0;
HWND dosshark_memview = 0;
HWND dosshark_about = 0;


void inject(ccode * code)
{
	WriteProcessMemory(DOSBOX_HANDLE,(LPVOID)ds_start+code->offset,&code->value,code->size,0);
}

void SaveCodeList(HWND hwnd)
{
	char * fnbuf = malloc(MAX_PATH);
	fnbuf[0]=0;
	OPENFILENAME open;
	memset(&open,0,sizeof(OPENFILENAME));
	open.lStructSize = sizeof(OPENFILENAME);
    open.hwndOwner = hwnd;
    open.lpstrFilter = "All Files (*.*)\0*.*\0";
    open.lpstrFile = fnbuf;
    open.nMaxFile = MAX_PATH;
	open.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	open.lpstrTitle = "Save cheat-code list";
	
	HWND s_hwnd = GetDlgItem(dosshark_codes,DS_CODES_LIST);
	int c,i;
	
	FILE * fp;
	if(GetSaveFileName(&open))
    {
		fp = fopen(fnbuf,"wb");
		c=SendMessage(s_hwnd,LB_GETCOUNT,0,0);
		
		for(i=0;i<c;++i)
		{
			SendMessage(s_hwnd,LB_GETTEXT,i,(LPARAM)buf);
			fprintf(fp,"%s\n",&buf[3]);
		}
		
		fclose(fp);
		MessageBox(hwnd,"Saved!","SUCESS",0);
    }
	free(fnbuf);
}

void LoadCodeList(HWND hwnd)
{
	ccode bx;
	char * fnbuf = malloc(MAX_PATH);
	fnbuf[0]=0;
	OPENFILENAME open;
	memset(&open,0,sizeof(OPENFILENAME));
	open.lStructSize = sizeof(OPENFILENAME);
    open.hwndOwner = hwnd;
    open.lpstrFilter = "All Files (*.*)\0*.*\0";
    open.lpstrFile = fnbuf;
    open.nMaxFile = MAX_PATH;
	open.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	open.lpstrTitle = "Load cheat-code list";
	
	HWND s_hwnd = GetDlgItem(dosshark_codes,DS_CODES_LIST);
	
	FILE * fp;
	if(GetSaveFileName(&open))
    {
		fp = fopen(fnbuf,"rb");
		while(!feof(fp))
		{
			buf[0]='[';
			buf[1]='X';
			buf[2]=']';
			if(fscanf(fp,"%[^\t\n]\n",&buf[3]))
			{
				if(!load_ccode(&bx,&buf[28]))
				{
					if(MessageBox(hwnd,"There appears to be corrupt codes.\nDo you want to continue loading?","Error",MB_YESNO) == IDNO)
					{
						break;
					}
				}
				SendMessage(s_hwnd,LB_ADDSTRING,0,(LPARAM)buf);
			}
		}
		fclose(fp);
    }
	free(fnbuf);
}

void ToggleCode(int onoff)
{
	HWND hwnd = GetDlgItem(dosshark_codes,DS_CODES_LIST);
	int id=SendMessage(hwnd,LB_GETCARETINDEX,0,0);
	int max=SendMessage(hwnd,LB_GETCOUNT,0,0);
	int i;
	SendMessage(hwnd,WM_SETREDRAW,0,0);
	int gc1 = SendMessage(hwnd,LB_GETCURSEL,0,0);
	for(i=0;i<max;++i)
	{
		SendMessage(hwnd,LB_GETTEXT,0,(LPARAM)buf);
		
		if(i==id)
		{
			if(onoff)
			{
				buf[1]='O';
			}
			else
			{
				buf[1]='X';
			}
		}
		
		SendMessage(hwnd,LB_DELETESTRING,0,0);
		SendMessage(hwnd,LB_ADDSTRING,0,(LPARAM)buf);
	}
	SendMessage(hwnd,LB_SETCURSEL,gc1,0);
	SendMessage(hwnd,WM_SETREDRAW,1,0);
}

int mem_current = 0;

char refreshing=0;
void memview_refresh(void)
{
	if(refreshing){return;}
	refreshing=1;
	HWND mv = GetDlgItem(dosshark_memview,DS_MEMVIEW_MV);
	SendMessage(mv,WM_SETREDRAW,0,0);
	int gc1 = SendMessage(mv,LB_GETCURSEL,0,0);
	int gc2 = SendMessage(mv,LB_GETTOPINDEX,0,0);
	if(gc1 == -1){gc1=0;}
	
	SendMessage(mv,LB_RESETCONTENT,0,0);
	char buf[100];
	char b;
	
	int stt=mem_current*SCAN_MNT;
	int end=(mem_current+1)*SCAN_MNT;
	int j;
	
	while(stt<end)
	{
		sprintf(buf,"%.6X ",stt);
		for(j=0;j<12;++j,++stt)
		{
			if(stt==end){break;}
			b=0;
			ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)ds_start+stt,&b,1,0);
			sprintf(&buf[7+(j*3)],"%.2x ",((int)b)&0xFF);
		}
		
		SendMessage(mv,LB_ADDSTRING,0,(LPARAM)buf);
	}
	
	
	SendMessage(mv,LB_SETCURSEL,gc1,0);
	SendMessage(mv,LB_SETTOPINDEX,gc2,0);
	SendMessage(mv,WM_SETREDRAW,1,0);
	refreshing=0;
}

void update_memcurrent(int ad0)
{
	GetDlgItemText(dosshark_memview,DS_MEMVIEW_PAGE,buf,10);
	int mc = atoi(buf)+ad0;
	
	if(mc < 0){mc=0;}
	if(mc >= MEMVIEW_MAX){mc=(MEMVIEW_MAX-1);}
	
	mem_current=mc;
	sprintf(buf,"%u",mem_current);
	SetDlgItemText(dosshark_memview,DS_MEMVIEW_PAGE,buf);
	memview_refresh();
}


WINAPI __thread_memview_update(void * a)
{
	while(attached)
	{
		memview_refresh();
		Sleep(500);
	}
}

HFONT base;
HFONT bold;
LOGFONT fbuf;

void SetSearchPos(int percent)
{
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_BAR),PBM_SETPOS,percent,0);
}

int smode=0;

void NewST(void)
{
	TempScanClean();
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_RESETCONTENT,0,0);
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Exact");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Unknown value");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_SETCURSEL,0,0);
	Enable(dosshark_scanner,DS_SCANNER_SZ);
	smode=0;
}

void NextST(void)
{
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_RESETCONTENT,0,0);
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Exact");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Changed");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Unchanged");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Increased");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Decreased");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Less than");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Less or equal");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Greater than");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_ADDSTRING,0,(LPARAM)"Greater or equal");
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_SETCURSEL,0,0);
	Disable(dosshark_scanner,DS_SCANNER_SZ);
	smode=1;
}

WINAPI __thread_injector(void * a)
{
	int i,c;
	char cuf[99];
	ccode bx;
	HWND hwnd = GetDlgItem(dosshark_codes,DS_CODES_LIST);
	for(;;)
	{
		if(attached)
		{
			c=SendMessage(hwnd,LB_GETCOUNT,0,0);
			for(i=0;i<c;++i)
			{
				SendMessage(hwnd,LB_GETTEXT,0,(LPARAM)cuf);
				if(cuf[1]=='O')
				{
					load_ccode(&bx,&cuf[28]);
					inject(&bx);
				}
			}
		}
		Sleep(50);
	}
}

WINAPI __thread_update_info(void* a)
{
	char sbuf[25];
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)PTR_TO_START,&ds_base,4,0);
	ds_start=ds_base+START_ADDON;
	sprintf(sbuf,"0x%.8x",ds_base);
	SetDlgItemText(dosshark_main,DS_ATTACH_BASEADDR,sbuf);
	sprintf(sbuf,"0x%.8x",ds_start);
	SetDlgItemText(dosshark_main,DS_ATTACH_CODESTART,sbuf);
	
	while(attached)
	{
		memset(ds_path,0,256);
		memset(ds_name,0,9);
		ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)ds_base+PATH_ADDON,ds_path,255,0);
		ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)ds_base+NAME_ADDON,ds_name,8,0);
		SetDlgItemText(dosshark_main,DS_ATTACH_PATH,ds_path);
		SetDlgItemText(dosshark_main,DS_ATTACH_NAME,ds_name);
		Sleep(500);
	}
	
	return 1;
}


void f_exact_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,c=0;
	FILE * fp = fopen("scan.tmp","wb");
	int t = time(0);
	for(i=0;i<SCAN_SIZE;++i)
	{
		buffer=((int*)(&bc[i]))[0] & (0xFFFFFFFF>>((4-size)*8));
		if(buffer==value)
		{
			sprintf(dbuf,"%.6x:%u",i,buffer);
			fprintf(fp,"%s\n",dbuf);
			++c;
			if(c<0x1000)
			{
				SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
			}
		}
		if(time(0)-t)
		{
			SetSearchPos(((i*100)/SCAN_SIZE));
			sprintf(dbuf,"%u results",c);
			SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
			t=time(0);
		}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
}

void f_unknown_scan(int size, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,c=0;
	FILE * fp = fopen("scan.tmp","wb");
	int t = time(0);
	for(i=0;i<SCAN_SIZE;++i)
	{
		buffer=((int*)(&bc[i]))[0] & (0xFFFFFFFF>>((4-size)*8));
		sprintf(dbuf,"%.6x:%u",i,buffer);
		fprintf(fp,"%s\n",dbuf);
		++c;
		if(time(0)-t)
		{
			SetSearchPos(((i*100)/SCAN_SIZE));
			sprintf(dbuf,"%u results",c);
			SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
			t=time(0);
		}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
}

void n_exact_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&buffer))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value==buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_changed_scan(int size, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,value,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&value))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value!=buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_unchanged_scan(int size, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,value,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&value))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value==buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_increased_scan(int size, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,value,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&value))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value<buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_decreased_scan(int size, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,value,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&value))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value>buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}


void n_less_than_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&buffer))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value>buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_less_or_equal_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&buffer))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value>=buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_greater_than_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&buffer))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value<buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

void n_greater_or_equal_scan(int size, int value, HWND out)
{
	char dbuf[100];
	char fbuf[12];
	int i,buffer,offset,c=0;
	FILE * fp = fopen("scan.tmp","rb");
	FILE * fp2 = fopen("scan2.tmp","wb");
	GetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf,99);
	if(atoi(dbuf)==0){return;}
	int t = time(0);
	int amt = atoi(fbuf);
	while(!feof(fp))
	{
		if(fscanf(fp,"%x:%u\n",&offset,&buffer))
			{
				buffer=((int*)(&bc[offset]))[0] & (0xFFFFFFFF>>((4-size)*8));
				if(value<=buffer)
				{
					sprintf(dbuf,"%.6x:%u",offset,buffer);
					fprintf(fp2,"%s\n",dbuf);
					if(i<0x1000)
					{
						SendMessage(out,LB_ADDSTRING,0,(LPARAM)dbuf);
					}
					++c;
				}
				++i;
			}
			if(time(0)-t)
			{
				SetSearchPos((i*100)/amt);
				sprintf(dbuf,"%u results",c);
				SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
				t=time(0);
			}
	}
	SetSearchPos(100);
	sprintf(dbuf,"%u results",c);
	SetDlgItemText(dosshark_scanner,DS_SCANNER_RES,dbuf);
	fclose(fp);
	fclose(fp2);
	remove("scan.tmp");
	rename("scan2.tmp","scan.tmp");
}

WINAPI __thread_search(void)
{
	Disable(dosshark_scanner,DS_SCANNER_SCAN);
	Disable(dosshark_scanner,DS_SCANNER_SZ);
	Disable(dosshark_scanner,DS_SCANNER_ST);
	char sbuf[100];
	int val,sz;
	GetDlgItemText(dosshark_scanner,DS_SCANNER_SCAN,sbuf,10);
	val=atoi(sbuf);
	sz=SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_GETCURSEL,0,0)+1;
	SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_GETLBTEXT,SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_ST),CB_GETCURSEL,0,0),(LPARAM)sbuf);
	ReadProcessMemory(DOSBOX_HANDLE,(LPCVOID)ds_start,bc,SCAN_SIZE,0);
	HWND out = GetDlgItem(dosshark_scanner,DS_SCANNER_LIST);
	
	if(!smode)
	{
		if(strcmp("Exact",sbuf)==0){f_exact_scan(sz,val,out);}
		if(strcmp("Unknown value",sbuf)==0){f_unknown_scan(sz,out);}
	}
	else
	{
		if(strcmp("Exact",sbuf)==0){n_exact_scan(sz,val,out);}
		if(strcmp("Changed",sbuf)==0){n_changed_scan(sz,out);}
		if(strcmp("Unchanged",sbuf)==0){n_unchanged_scan(sz,out);}
		if(strcmp("Increased",sbuf)==0){n_increased_scan(sz,out);}
		if(strcmp("Decreased",sbuf)==0){n_decreased_scan(sz,out);}
		if(strcmp("Less than",sbuf)==0){n_less_than_scan(sz,val,out);}
		if(strcmp("Less or equal",sbuf)==0){n_less_or_equal_scan(sz,val,out);}
		if(strcmp("Greater than",sbuf)==0){n_greater_than_scan(sz,val,out);}
		if(strcmp("Greater or equal",sbuf)==0){n_greater_or_equal_scan(sz,val,out);}
	}
	
	Enable(dosshark_scanner,DS_SCANNER_SCAN);
	Enable(dosshark_scanner,DS_SCANNER_SZ);
	Enable(dosshark_scanner,DS_SCANNER_ST);
	scanning=0;
	if(!smode)
	{
		NextST();
	}
	return 1;
}

LRESULT CALLBACK SubsAddCdDlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg == WM_INITDIALOG)
	{
		memset(buf,0,100);
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);
		sprintf(buf,"%i",SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_GETCURSEL,0,0)+1);
		SetDlgItemText(hWndDlg,DS_CREATECODE_SIZE,buf);
		SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_LIST),LB_GETTEXT,SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_LIST),LB_GETCARETINDEX,0,0),(LPARAM)buf);
		buf[6]=0;
		SetDlgItemText(hWndDlg,DS_CREATECODE_OFFSET,buf);
		SetDlgItemText(hWndDlg,DS_CREATECODE_VALUE,&buf[7]);
	}
	
	if(Msg == WM_CLOSE)
	{
		EndDialog(hWndDlg,0);
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam)==DS_CREATECODE_CANCEL)
		{
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam) == DS_CREATECODE_OK)
		{
			ccode code;
			GetDlgItemText(hWndDlg,DS_CREATECODE_SIZE,buf,2);
			code.size=atoi(buf);
			if((code.size < 1)||(code.size > 4))
			{
				MessageBox(hWndDlg,"Size must be between 1-4",buf,0);
				return TRUE;
			}
			
			GetDlgItemText(hWndDlg,DS_CREATECODE_OFFSET,buf,9);
			code.offset=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_CREATECODE_VALUE,buf,9);
			code.value=(atoi(buf) & (0xFFFFFFFF>>((4-code.size)*8)));
			
			memset(buf,' ',97);
			buf[98]=0;
			buf[0]='[';
			buf[1]='X';
			buf[2]=']';
			GetDlgItemText(hWndDlg,DS_CREATECODE_NAME,&buf[3],24);
			buf[strlen(buf)]=' ';
			save_ccode(&code,&buf[28]);
			SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_ADDSTRING,0,(LPARAM)buf);
			MessageBox(hWndDlg,"Code Added!","SUCESS",0);
			EndDialog(hWndDlg,0);
		}
		
		return TRUE;
	}
	
	return FALSE;
}

LRESULT CALLBACK SubsAddCDlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg == WM_INITDIALOG)
	{
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);	
	}
	
	if(Msg == WM_CLOSE)
	{
		EndDialog(hWndDlg,0);
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam)==DS_ADDCODE_CANCEL)
		{
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam) == DS_ADDCODE_OK)
		{
			ccode code;
			memset(buf,' ',97);
			buf[98]=0;
			buf[0]='[';
			buf[1]='X';
			buf[2]=']';
			GetDlgItemText(hWndDlg,DS_ADDCODE_NAME,&buf[3],24);
			buf[strlen(buf)]=' ';
			
			
			GetDlgItemText(hWndDlg,DS_ADDCODE_CODE,&buf[28],25);
			if(load_ccode(&code,&buf[28]) < 3)
			{
				MessageBox(hWndDlg,"Invald code","Error",0);
				return TRUE;
			}
			
			if((code.size > 4) || (code.size < 1))
			{
				MessageBox(hWndDlg,"Code size must be between 1-4","Error",0);
				return TRUE;
			}
			
			save_ccode(&code,&buf[28]);
			SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_ADDSTRING,0,(LPARAM)buf);
			EndDialog(hWndDlg,0);
		}
		
		return TRUE;
	}
	
	return FALSE;
}

LRESULT CALLBACK SubsEditDlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg == WM_INITDIALOG)
	{
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);	
		if(mem_current<0){mem_current=0;}
		int st = mem_current*SCAN_MNT+(12*(SendMessage(GetDlgItem(dosshark_memview,DS_MEMVIEW_MV),LB_GETCURSEL,0,0)));
		sprintf(buf,"%.6X-%.6X",st,st+11);
		SetDlgItemText(hWndDlg,DS_EDITMEM_RANGE,buf);
		SendMessage(GetDlgItem(dosshark_memview,DS_MEMVIEW_MV),LB_GETTEXT,SendMessage(GetDlgItem(dosshark_memview,DS_MEMVIEW_MV),LB_GETCURSEL,0,0),(LPARAM)buf);
		
		buf[9]=0;buf[12]=0;buf[15]=0;buf[18]=0;buf[21]=0;buf[24]=0;
		buf[27]=0;buf[30]=0;buf[33]=0;buf[36]=0;buf[39]=0;buf[42]=0;
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL1,&buf[7]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL2,&buf[10]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL3,&buf[13]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL4,&buf[16]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL5,&buf[19]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL6,&buf[22]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL7,&buf[25]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL8,&buf[28]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL9,&buf[31]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL10,&buf[34]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL11,&buf[37]);
		SetDlgItemText(hWndDlg,DS_EDITMEM_VAL12,&buf[40]);
		
	}
	
	if(Msg == WM_CLOSE)
	{
		EndDialog(hWndDlg,0);
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam)==DS_EDITMEM_CANCEL)
		{
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam)==DS_EDITMEM_OK)
		{
			int i;
			char sbuf[12];
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL1,buf,99);sbuf[0]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL2,buf,99);sbuf[1]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL3,buf,99);sbuf[2]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL4,buf,99);sbuf[3]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL5,buf,99);sbuf[4]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL6,buf,99);sbuf[5]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL7,buf,99);sbuf[6]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL8,buf,99);sbuf[7]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL9,buf,99);sbuf[8]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL10,buf,99);sbuf[9]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL11,buf,99);sbuf[10]=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,DS_EDITMEM_VAL12,buf,99);sbuf[11]=strtol(buf,0,16);
			
			int addr = mem_current*SCAN_MNT+(12*(SendMessage(GetDlgItem(dosshark_memview,DS_MEMVIEW_MV),LB_GETCURSEL,0,0)))+ds_start;
			WriteProcessMemory(DOSBOX_HANDLE,(LPVOID)addr,&sbuf,12,0);
			EndDialog(hWndDlg,0);
		}
		
		
		return TRUE;
	}
	
	
	return FALSE;
}

LRESULT CALLBACK DlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	
	if(Msg == WM_INITDIALOG)
	{
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);
	    SendMessage(hWndDlg, WM_SETICON, ICON_BIG  , (LPARAM)hIcon);
	    SendMessage(hWndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIconSm);
		
		HWND tab_x = GetDlgItem(hWndDlg,DS_TAB32);
		TCITEM ti;
		memset(&ti,0,sizeof(TCITEM));
		ti.mask = TCIF_TEXT;
		ti.pszText="DOSBox";
		SendMessage(tab_x,TCM_INSERTITEM,0,(LPARAM)&ti);
		ti.pszText="Scanner";
		SendMessage(tab_x,TCM_INSERTITEM,1,(LPARAM)&ti);
		ti.pszText="Codes";
		SendMessage(tab_x,TCM_INSERTITEM,2,(LPARAM)&ti);
		ti.pszText="Memory View";
		SendMessage(tab_x,TCM_INSERTITEM,3,(LPARAM)&ti);
		ti.pszText="About";
		SendMessage(tab_x,TCM_INSERTITEM,4,(LPARAM)&ti);
		
		if(!dosshark_main)
		{
			dosshark_main=hWndDlg;
			dosshark_scanner=CreateDialog(hInstance,MAKEINTRESOURCE(DIALOG_SCANNER),0,(DLGPROC)DlgProc);
			dosshark_codes=CreateDialog(hInstance,MAKEINTRESOURCE(DIALOG_CODES),0,(DLGPROC)DlgProc);
			dosshark_memview=CreateDialog(hInstance,MAKEINTRESOURCE(DIALOG_MEMVIEW),0,(DLGPROC)DlgProc);
			dosshark_about=CreateDialog(hInstance,MAKEINTRESOURCE(DIALOG_ABOUT),0,(DLGPROC)DlgProc);
			
			PAINTSTRUCT ps;
			HDC hdc;
			
			hdc = BeginPaint(dosshark_about,&ps);
			base=(HFONT)SendDlgItemMessage(dosshark_about,DS_ABOUT_DSX,WM_GETFONT,0,0);
			HGDIOBJ selc = SelectObject(hdc,base);
			GetObject(selc,sizeof(LOGFONT),&fbuf);
			strcpy(fbuf.lfFaceName,DIALOG_FONTFC);
			EndPaint(dosshark_about,&ps);
			fbuf.lfWeight=FW_BOLD;
			bold=CreateFontIndirect(&fbuf);
			SendDlgItemMessage(dosshark_about,DS_ABOUT_DSX,WM_SETFONT,(WPARAM)bold,(LPARAM)TRUE);
			
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_ADDSTRING,0,(LPARAM)"1 Byte");
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_ADDSTRING,0,(LPARAM)"2 Byte");
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_ADDSTRING,0,(LPARAM)"3 Byte");
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_ADDSTRING,0,(LPARAM)"4 Byte");
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_SZ),CB_SETCURSEL,0,0);
			
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_BAR),PBM_SETRANGE32,0,100);
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_BAR),PBM_SETBKCOLOR,0,0x663333);
			SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_BAR),PBM_SETBARCOLOR,0,0x996666);
			SetSearchPos(0);
			
			NewST();
			
		}
	}
	
	if(Msg == WM_CLOSE)
	{
		if(MessageBox(hWndDlg,"Are you sure you want to exit?","Confirm Exit",MB_YESNO) == IDYES)
		{
			fcloseall();
			TempScanClean();
			PostQuitMessage(0);
			ExitProcess(0);
		}
	}
	
	if(Msg == WM_NOTIFY)
	{
		static last_sel;
		if(LOWORD(wParam)==DS_TAB32)
		{
			RECT rct;
			GetWindowRect(hWndDlg,&rct);
			int tabSel = SendDlgItemMessage(hWndDlg,DS_TAB32,TCM_GETCURSEL,0,0);
			
			if(last_sel == tabSel){return FALSE;}
			last_sel = tabSel;
						
			if(tabSel == 0)
			{
				ShowWindow(dosshark_main,SW_SHOW);
				SetWindowPos(dosshark_main,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosshark_main,DS_TAB32,TCM_SETCURSEL,0,0);
			}
			
			if(tabSel == 1)
			{
				ShowWindow(dosshark_scanner,SW_SHOW);
				SetWindowPos(dosshark_scanner,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosshark_scanner,DS_TAB32,TCM_SETCURSEL,1,0);
			}
			
			if(tabSel == 2)
			{
				ShowWindow(dosshark_codes,SW_SHOW);
				SetWindowPos(dosshark_codes,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosshark_codes,DS_TAB32,TCM_SETCURSEL,2,0);
			}
			
			if(tabSel == 3)
			{
				ShowWindow(dosshark_memview,SW_SHOW);
				SetWindowPos(dosshark_memview,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosshark_memview,DS_TAB32,TCM_SETCURSEL,3,0);
			}
			
			if(tabSel == 4)
			{
				ShowWindow(dosshark_about,SW_SHOW);
				SetWindowPos(dosshark_about,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosshark_about,DS_TAB32,TCM_SETCURSEL,4,0);
			}
			
			ShowWindow(hWndDlg,SW_HIDE);
		}
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam)==DS_ATTACH_DOSBOX)
		{
			attached=0;
			if(!FindDOSBOX())
			{
				MessageBox(hWndDlg,"Could not open DOSBox process","Error",0);
				return TRUE;
			}
			Sleep(500);
			attached=1;
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)__thread_update_info,0,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)__thread_memview_update,0,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)__thread_injector,0,0,0);
		}
		
		if(LOWORD(wParam)==DS_MEMVIEW_SET)
		{
			update_memcurrent(0);
		}
		
		if(LOWORD(wParam)==DS_MEMVIEW_NEXT)
		{
			update_memcurrent(1);
		}
		
		if(LOWORD(wParam)==DS_MEMVIEW_PREV)
		{
			update_memcurrent(-1);
		}
		
		if(LOWORD(wParam)==DS_MEMVIEW_EDIT)
		{
			if(attached)
			{
				DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_EDIT_MEM),hWndDlg,(DLGPROC)SubsEditDlgProc);
			}
			else
			{
				MessageBox(hWndDlg,"You need to attach to DOSBox first","Error",0);
			}
		}
		
		if(LOWORD(wParam) == DS_CODES_LOAD)
		{
			LoadCodeList(hWndDlg);
		}
		
		if(LOWORD(wParam) == DS_CODES_SAVE)
		{
			SaveCodeList(hWndDlg);
		}
		
		if(LOWORD(wParam)==DS_CODES_DEL)
		{
			int gc1 = SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_GETCURSEL,0,0);
			SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_DELETESTRING,gc1,0);
			if(SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_GETCOUNT,0,0) <= gc1)
			{
				--gc1;
			}
			SendMessage(GetDlgItem(dosshark_codes,DS_CODES_LIST),LB_SETCURSEL,gc1,0);
		}
		
		if(LOWORD(wParam)==DS_CODES_ADD)
		{
			DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_ADD_CODE),hWndDlg,(DLGPROC)SubsAddCDlgProc);
		}
		
		if(LOWORD(wParam)==DS_CODES_ACT)
		{
			ToggleCode(1);
		}
		
		if(LOWORD(wParam)==DS_CODES_DEC)
		{
			ToggleCode(0);
		}
		
		if(LOWORD(wParam)==DS_SCANNER_NS)
		{
			if(!scanning)
			{
				SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_LIST),LB_RESETCONTENT,0,0);
				SetSearchPos(0);
				NewST();
			}
		}
		
		if(LOWORD(wParam)==DS_SCANNER_SEARCH)
		{
			if(!scanning)
			{
				if(attached)
				{
					SendMessage(GetDlgItem(dosshark_scanner,DS_SCANNER_LIST),LB_RESETCONTENT,0,0);
					SetSearchPos(0);
					
					scanning=1;
					CreateThread(0,0,(LPTHREAD_START_ROUTINE)__thread_search,0,0,0);
				}
				else
				{
					MessageBox(hWndDlg,"You need to attach to DOSBox first","Error",0);
				}
			}
		}
		
		if(LOWORD(wParam)==DS_SCANNER_ADD)
		{
			if(!scanning)
			{
				if(attached)
				{
					DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_CREATE_CODE),hWndDlg,(DLGPROC)SubsAddCdDlgProc);
				}
				else
				{
					MessageBox(hWndDlg,"You need to attach to DOSBox first","Error",0);
				}
			}
		}
		
		return TRUE;
	}
	
	return FALSE;
}




int dsmain(void)
{
	TempScanClean();
	INITCOMMONCONTROLSEX icx;
	icx.dwSize=sizeof(icx);
	icx.dwICC=ICC_LISTVIEW_CLASSES|ICC_TAB_CLASSES;
	InitCommonControlsEx(&icx);
	
	hInstance = GetModuleHandle(0);
	hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(DS_ICON), IMAGE_ICON, 32, 32, 0);
	hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(DS_ICON), IMAGE_ICON, 16, 16, 0);
	
	DialogBox(hInstance, MAKEINTRESOURCE(DIALOG_MAIN),0,(DLGPROC)DlgProc);
}
